// IpMonThread.cpp : implementation file
//

#include "stdafx.h"

#pragma warning (disable: 4786)

#include "ipmona.h"
#include "IpMonThread.h"
#include "msgTimer.h"
#include "constants.h"
#include <string>
#include <winsock.h>
#include <iphlpapi.h>
#include "MailMessage.h"
#include "SMTP.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CString g_strFrom;
extern CString g_strDestinations;
extern CString g_strSubject;
extern CString g_strSMTPServer;

/////////////////////////////////////////////////////////////////////////////
// CIpMonThread

IMPLEMENT_DYNCREATE(CIpMonThread, CWinThread)

CIpMonThread::CIpMonThread()
{
}

// ------------------------------------------------------------------------- //

CIpMonThread::~CIpMonThread()
{
}

// ------------------------------------------------------------------------- //

BOOL CIpMonThread::InitInstance()
{
	m_bStopTimer = false;

	TRACE("---Starting timer\n");
	CWinThread* wt = MsgTimer(m_nThreadID, 1, 100, WM_USER_CHECKIP, &m_bStopTimer);

	return TRUE;
}

// ------------------------------------------------------------------------- //

int CIpMonThread::ExitInstance()
{
	m_bStopTimer = true;
	Sleep(1000L);
	return CWinThread::ExitInstance();
}

// ------------------------------------------------------------------------- //

BEGIN_MESSAGE_MAP(CIpMonThread, CWinThread)
	//{{AFX_MSG_MAP(CIpMonThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER_CHECKIP, OnCheckIP)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIpMonThread message handlers

LRESULT CIpMonThread::OnCheckIP(WPARAM, LPARAM)
{
	TRACE("---Getting timer\n");

	tdSet setNewAddr = PollIps();
	if (!IsEqual(m_setAddr, setNewAddr))
	{
		SendMsg(setNewAddr);
		m_setAddr = setNewAddr;
	}

	return 0;
}

// ------------------------------------------------------------------------- //

bool CIpMonThread::IsEqual(const tdSet& lhs, const tdSet& rhs)
{
	return (lhs == rhs);
}

// ------------------------------------------------------------------------- //

void CIpMonThread::SendMsg(const tdSet& src)
{
	TRACE("---sendmsg---\n");

	std::string sIp;

	for (tdSet::const_iterator cit = src.begin(); cit != src.end(); ++cit)
	{
		DWORD dwAddr = *cit;
		in_addr ia;
		ia.S_un.S_addr = dwAddr;
		sIp += inet_ntoa(ia);
		sIp += "; ";
	}

	CMainFrame* pMF = (CMainFrame*)AfxGetMainWnd();

	if (g_strFrom.IsEmpty()) return;
	if (g_strDestinations.IsEmpty()) return;
	if (g_strSMTPServer.IsEmpty()) return;

	CMailMessage msg;
//	msg.m_sFrom = "ipsrv@wehlou.com";
	msg.m_sFrom = g_strFrom;

//	msg.AddMultipleRecipients("martin<martin@wehlou.com>;mw<martin.wehlou@pandora.be>");
	msg.AddMultipleRecipients(g_strDestinations);

//	msg.m_sSubject = "ipsrv update";
	msg.m_sSubject = g_strSubject;

	msg.m_sBody = sIp.c_str();


//	CSMTP smtp("mail-out.pandora.be");
	CSMTP smtp(g_strSMTPServer);

	TRACE("-Connecting\n");

	smtp.Connect();
	TRACE("-Sending\n");
	smtp.SendMessage(&msg);
	TRACE("-Disconnecting\n");
	smtp.Disconnect();

//	in_addr	ia;
//	ia.S_un.S_addr = dwAddr;

//	std::string sIp = inet_ntoa(ia);
	TRACE("---%s---\n", sIp.c_str());
}

// ------------------------------------------------------------------------- //

tdSet CIpMonThread::PollIps()
{
	PMIB_IPADDRTABLE	pBuf = NULL;
	ULONG				lBufSize = 0;
	ULONG				lOldSize = 0;

	// get needed size first
	while(1)
	{
		GetIpAddrTable(pBuf, &lBufSize, false);
		if (lBufSize == lOldSize) break;
		if (pBuf != NULL) free(pBuf);
		pBuf = (PMIB_IPADDRTABLE)malloc(lBufSize);
		lOldSize = lBufSize;
	}

	MIB_IPADDRROW ipRow;
	DWORD nEntries = pBuf->dwNumEntries;

	tdSet newSet;

	for (DWORD i = 0; i < nEntries; i++)
	{
		memcpy(&ipRow, &(pBuf->table[i]), sizeof(MIB_IPADDRROW));

		DWORD dwAddr = ipRow.dwAddr;

		newSet.insert(dwAddr);

//		in_addr	ia;
//		ia.S_un.S_addr = dwAddr;

//		std::string sIp = inet_ntoa(ia);
//		fs << sIp << "\n";

//		DWORD dwIndex = ipRow.dwIndex;
//		DWORD dwMask = ipRow.dwMask;
//		DWORD dwBCastAddr = ipRow.dwBCastAddr;
	}
//	fs.close();
	free(pBuf);

	return newSet;
}

