// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ipmona.h"

#include "MainFrm.h"
#include "SetupInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame


CString	g_strSubject;
CString g_strDestinations;
CString	g_strSMTPServer;
CString g_strFrom;



IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_OPTIONS, OnFileOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	g_strDestinations = "";
	g_strFrom = "";
	g_strSMTPServer = "";
	g_strSubject = "";
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	LoadRegData();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnFileOptions() 
{
	
	CSetupInfo dlg;
	dlg.m_strDestinations = g_strDestinations;
	dlg.m_strSMTPServer = g_strSMTPServer;
	dlg.m_strSubject = g_strSubject;
	dlg.m_strFrom = g_strFrom;

	if (dlg.DoModal() == IDOK) {
		g_strDestinations = dlg.m_strDestinations;
		g_strSMTPServer = dlg.m_strSMTPServer;
		g_strSubject = dlg.m_strSubject;
		g_strFrom = dlg.m_strFrom;
		SaveRegData();
	}
}

void CMainFrame::LoadRegData()
{
	char	buf[1024];

	GetProfileString("IpMona", "Subject", "IpMona update", buf, sizeof(buf));
	g_strSubject = buf;

	GetProfileString("IpMona", "Destinations", "", buf, sizeof(buf));
	g_strDestinations = buf;

	GetProfileString("IpMona", "SMTPServer", "", buf, sizeof(buf));
	g_strSMTPServer = buf;

	GetProfileString("IpMona", "From", "", buf, sizeof(buf));
	g_strFrom = buf;
}

void CMainFrame::SaveRegData()
{
	WriteProfileString("IpMona", "Subject", g_strSubject);
	WriteProfileString("IpMona", "Destinations", g_strDestinations);
	WriteProfileString("IpMona", "SMTPServer", g_strSMTPServer);
	WriteProfileString("IpMona", "From", g_strFrom);
}